public class fcarc extends ImgFilt {
    int amplitude = 10;
    int frequency = 10;
    int xtrans = 0;
    int ytrans = 0;
    int beginrange = -1;
    int endrange = -1;

    public void setparameter(String param, int i) {
        switch(i) {
        case 0:
            amplitude = Integer.parseInt(param);
            break;
        case 1:
            frequency = Integer.parseInt(param);
            break;
        case 2:
            xtrans = Integer.parseInt(param);
            break;
        case 3:
            ytrans = Integer.parseInt(param);
            break;
        case 4:
            beginrange = Integer.parseInt(param);
            break;
        case 5:
            endrange = Integer.parseInt(param);
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y;
        int index, new_index;
        int newx, newy;
        int newh;
	int oldx, oldy, oldindex;
        int i;
        int bg_value;
        int abs_amplitude = Math.abs(amplitude);
        int new_size;
        ftransp tp;
	double r,a, newr;

        if(p1.length != (w*h)) {
            System.out.println("carc filter: got array of wrong size");
            return null;
        }

        new_size = w*h;
        newpixels = new int[new_size];

        // Initialize the newpixels so we don't end up with
        // transparent background for pixels that are not
        // directly written to
        bg_value = 0xff000000 | 
                   (bg.getRed() << 16) |
                   (bg.getGreen() << 8) |
                    bg.getBlue();
        for(i=0;i<new_size;i++)
            newpixels[i] = bg_value;
        new_index = 0;
        for(y=0;y<h;y++) {
            for(x=0;x<w;x++) {
                index =  (y*w) + x;
		newx = x - (w/2);
		newy = y - (h/2);
		r = Math.sqrt((newx*newx) + (newy*newy));
		newr = Math.sqrt(r*(w/2));
		a = Math.atan((double)newx/(double)newy);
		oldx = (int)(Math.sin(a) * newr);
		oldy = (int)(Math.cos(a) * newr);
		newpixels[index] = p1[((oldy+(h/2))*w)+oldx+(w/2)];


		/*
		r = Math.sqrt((x*x) + (y*y));
		newr = Math.sqrt(r*h);
		a = Math.atan(((double)x)/((double)y));
		oldx = (int)(Math.sin(a) * newr);
		oldy = (int)(Math.cos(a) * newr);
		newpixels[index] = p1[(oldy*w)+oldx];
		*/
            }
        }
        new_width  = w;
        new_height = h;
        if(transparent) {
            tp = new ftransp();
            tp.setTransparentColor(bg);
            newpixels = tp.filter(newpixels, new_width, new_height);
        }
        return newpixels;
    }
}
