public class fembossimage extends ImgFilt {
    int pixels_col[][];
    int East[][] = { 
                    { -1,  0,  1},
                    { -1,  1,  1},
                    { -1,  0,  1}};
    int SouthEast[][] = { 
                    { -1, -1,  0},
                    { -1,  1,  1},
                    {  0,  1,  1}};
    int South[][] = { 
                    { -1, -1, -1},
                    {  0,  1,  0},
                    {  1,  1,  1}};
    int SouthWest[][] = { 
                    {  0, -1, -1},
                    {  1,  1, -1},
                    {  1,  1,  0}};
    int West[][] = { 
                    {  1,  0, -1},
                    {  1,  1, -1},
                    {  1,  0, -1}};
    int NorthWest[][] = { 
                    {  1,  1,  0},
                    {  1,  1, -1},
                    {  0, -1, -1}};
    int North[][] = { 
                    {  1,  1,  1},
                    {  0,  1,  0},
                    { -1, -1, -1}};
    int NorthEast[][] = { 
                    {  0,  1,  1},
                    { -1,  1,  1},
                    { -1, -1,  0}};

    int ef[][] = West;

    public void setparameter(String str_direction, int i) {
        if(str_direction.equalsIgnoreCase("East")) {
            ef = East;
        } else if(str_direction.equalsIgnoreCase("Southeast")) {
            ef = SouthEast;
        } else if(str_direction.equalsIgnoreCase("South")) {
            ef = South;
        } else if(str_direction.equalsIgnoreCase("SouthWest")) {
            ef = SouthWest;
        } else if(str_direction.equalsIgnoreCase("West")) {
            ef = West;
        } else if(str_direction.equalsIgnoreCase("NorthWest")) {
            ef = NorthWest;
        } else if(str_direction.equalsIgnoreCase("North")) {
            ef = North;
        } else if(str_direction.equalsIgnoreCase("NorthEast")) {
            ef = NorthEast;
        } else {
            ef = West;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y, xb, yb;
        int index, new_index;
        int imagesize = w*h;
        int red, green, blue;

        if(p1.length != (imagesize)) {
            System.out.println("emboss filter: got array of wrong size");
            return null;
        }
        newpixels = new int[imagesize];
        pixels_col = new int[imagesize][4];
        for(y=0;y<h;y++) {
            for(x=0;x<w;x++) {
                index =  (y*w) + x;
                pixels_col[index][1] += getRed  (p1[index]);
                pixels_col[index][2] += getGreen(p1[index]);
                pixels_col[index][3] += getBlue (p1[index]);
            }
        }

        for(y=0;y<h;y++) {
here:        for(x=0;x<w;x++) {
                red = green = blue = 0;
                index =  (y*w) + x;

                for(yb=-1;yb<=1;yb++) {
                    for(xb=-1;xb<=1;xb++) {
                        new_index = index + ((w*yb)+xb);
                        if(new_index < 0 || new_index >= imagesize) {
                            newpixels[index] = p1[index];
                            continue here;
                        }
                        if(x + xb >= w) {
                            newpixels[index] = p1[index];
                            continue here;
                        }
                        red   += (ef[yb+1][xb+1]*pixels_col[new_index][1]);
                        green += (ef[yb+1][xb+1]*pixels_col[new_index][2]);
                        blue  += (ef[yb+1][xb+1]*pixels_col[new_index][3]);
                        /*
                        if(xb == -1) {
                            red   -= pixels_col[new_index][1];
                            green -= pixels_col[new_index][2];
                            blue  -= pixels_col[new_index][3];
                        } else if(xb == 1) {
                            red   += pixels_col[new_index][1];
                            green += pixels_col[new_index][2];
                            blue  += pixels_col[new_index][3];
                        } else if(yb == 0 && xb == 0) {
                            red   += pixels_col[new_index][1];
                            green += pixels_col[new_index][2];
                            blue  += pixels_col[new_index][3];
                        } 
                        */
                    }
                }
                if(red < 0)
                    red = 0;
                else if(red > 255)
                    red = 255;
                if(green < 0)
                    green = 0;
                else if(green > 255)
                    green = 255;
                if(blue < 0)
                    blue = 0;
                else if(blue > 255)
                    blue = 255;
                newpixels[index] =
                        ((p1[index] & 0xff000000) |
                         ((red ) << 16) |
                         ((green) <<  8) |
                         ((blue)));
            }
        }
        new_width  = w;
        new_height = h;
        return newpixels;
    }

    public int getAlpha(int a) {
        return ((a&0xff000000) >>> 24);
    }

    public int getRed(int a) {
        return ((a&0x00ff0000) >> 16);
    }

    public int getGreen(int a) {
        return ((a&0x0000ff00) >> 8);
    }

    public int getBlue(int a) {
        return (a&0x000000ff);
    }
}
