public class fscale extends ImgFilt {
    int perc_width = 100;
    int perc_height = 100;

    public void setparameter(String str, int i) {
        switch(i) {
        case 0:
            perc_width = Integer.parseInt(str);
            break;
        case 1:
            perc_height = Integer.parseInt(str);
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y;
        int old_index, new_index;
        int old_size,  new_size;

        if(p1.length != (w*h)) {
            System.out.println("scale filter: got array of wrong size");
            return null;
        }

        new_width = (int)(w * perc_width/ 100);
        new_height = (int)(h * perc_height/ 100);
        old_size = w * h;
        new_size = new_width * new_height;

        newpixels = new int[new_width * new_height];
        new_index = 0;
        for(y=0;y<new_height;y++) {
            for(x=0;x<new_width;x++) {
                old_index =  ((y*100/perc_height)*w) + (x*100/perc_width);
                try {
                    newpixels[new_index++] = p1[old_index];
                } catch (ArrayIndexOutOfBoundsException e) {
                    System.out.println("y = " + y + " x = " + x);
                }
            }
        }
        return newpixels;
    }
}
