public class fslantdown extends ImgFilt {
    int angle = 45;             // In case it's not set
    double radians;

    public void setparameter(String str_angle, int i) {
        angle = Integer.parseInt(str_angle);
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y, i;
        int index, new_index;
        int slantoffset;
        int slantamount;

        if(p1.length != (w*h)) {
            System.out.println("slantdn filter: got array of wrong size");
            return null;
        }

        radians = Math.PI * (double)angle / 180.0;

        slantamount = (int)Math.round(Math.tan(radians) * w);
        newpixels = new int[(h + slantamount) * w];

        if(transparent == true)
            for(i=0;i<(w*(h + slantamount));i++)
                newpixels[i] = 0x00ffffff;
        else
            for(i=0;i<(w*(h + slantamount));i++)
                newpixels[i] = trans_color_value;

        new_index = 0;
        for(x=0;x<w;x++) {
            slantoffset = (int)Math.round(Math.tan(radians) * x);
            for(y=0;y<h;y++) {
                index = (y*w) + x;
                if(transparent == true) {
                    if(p1[index] != trans_color_value)
                        newpixels[((y+slantoffset)*w) + x] = p1[index];
                } else {
                    newpixels[((y+slantoffset)*w) + x] = p1[index];
                }
            }
        }
        new_width  = w;
        new_height = h + slantamount;
        return newpixels;
    }
}
