public class fslantleft extends ImgFilt {
    int angle = 45;             // In case it's not set
    double radians;

    public void setparameter(String str_angle, int i) {
        angle = Integer.parseInt(str_angle);
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y, i;
        int index, new_index;
        int slantoffset;
        int slantamount;

        if(p1.length != (w*h)) {
            System.out.println("slantlt filter: got array of wrong size");
            return null;
        }

        radians = Math.PI * (double)angle / 180.0;

        slantamount = (int)Math.round(Math.tan(radians) * h);
        newpixels = new int[(w + slantamount) * h];
        new_index = 0;
        for(y=0;y<h;y++) {
            slantoffset = (int)Math.round(Math.tan(radians) * y);
            for(i=0;i<slantoffset;i++)
                newpixels[new_index++] = transparent ? 
                                            0x00ffffff : 
                                            trans_color_value;
            for(x=0;x<w;x++) {
                index =  (y*w) + x;
                if(transparent == false) {
                    newpixels[new_index++] = p1[index];
                } else {
                    if(p1[index] == trans_color_value)  // Found trans_color
                        newpixels[new_index++] = 0x00ffffff;    // Make Transp
                    else
                        newpixels[new_index++] = p1[index];
                }
            }
            for(i=0;i<slantamount-slantoffset;i++)
                newpixels[new_index++] = transparent ? 0x00ffffff :
                                        trans_color_value;
        }
        new_width  = w + slantamount;
        new_height = h;
        return newpixels;
    }
}
