import java.awt.*;
import java.awt.image.*;

public class ftext extends ImgFilt {

    public int[] filter(int[] p1, int w, int h) {
        Image image;
        Graphics g;
        int ascent, descent;
        FontMetrics fontmetrics;
        int pixels[];
        boolean retval;
        ftransp tp;
	ImgGetr ig;

        // Ignore p1, w, and h

        fontmetrics = applet.getFontMetrics(font);
        ascent = fontmetrics.getAscent();
        descent = fontmetrics.getDescent();
        new_width = fontmetrics.stringWidth(tx);
        new_height = fontmetrics.getHeight();

        image = applet.createImage(new_width, new_height);
        g = image.getGraphics();
        g.setFont(font);
        g.setColor(bg);
        g.fillRect(0, 0, new_width, new_height);

        // Now draw the main foreground text
        g.setColor(fg);
        g.drawString(tx, 0, ascent);
        drawUnderline(g, fontmetrics, 0,
                        ascent+Math.max(1, (descent/4)),
                        new_width, fg);

        // Grab the pixels
	ig = new ImgGetr(applet);
        pixels = ig.getPixels(image, applet);
        if(transparent) {
            tp = new ftransp();
            tp.setTransparentColor(bg);
            pixels = tp.filter(pixels, new_width, new_height);
        }
        return pixels;
    }
}
