import java.awt.Color;

public class ftranscolor extends ImgFilt {
    int trans_colors[];

    public int[] filter(int[] p1, int w, int h) {
        int x, y, i;
        int index, new_index;
        int len;

        if(p1.length != (w*h)) {
            System.out.println("multrans filter: got array of wrong size");
            return null;
        }
        if(trans_colors == null)
            len = 0;
        else
            len = trans_colors.length;

        newpixels = new int[h * w];

        new_index = 0;
        for(y=0;y<h;y++) {
            for(x=0;x<w;x++) {
                index = (y*w) + x;

                // First copy the original color so that if we don't
                // find a color to make transparent, the original
                // value is in newpixel
                newpixels[new_index] = p1[index];

                // Search through each of the color in the list
                for(i=0;i<len;i++) {
                    if(p1[index] == trans_colors[i]) {
                        newpixels[new_index] = 0x00ffffff;
                        break;
                    }
                }
                new_index++;
            }
        }
        new_width  = w;
        new_height = h;
        return newpixels;
    }

    public void setparameter(String s, int i) {
        int t[];
        Color c;
        int old_length;
        int r, g, b;

        if(trans_colors == null)
            old_length = 0;
        else
            old_length = trans_colors.length;
        t = new int[old_length+1];
        for(i=0;i<old_length;i++)
            t[i] = trans_colors[i];
        trans_colors = t;
        c = String2Color(s);
        r = c.getRed();
        g = c.getGreen();
        b = c.getBlue();
        trans_colors[old_length] = 0xff000000 | (r << 16) | (g << 8) | b;
    }
}
