import java.awt.image.*;
import java.awt.Color;
import java.awt.*;

public class CropRoundRectangle extends OffScr {

    public void init() {
        fcroproundrect crr;
	String xoffset;
	String yoffset;
	String rectwidth;
	String rectheight;
	String arcwidth;
	String archeight;

        super.init();

        xoffset      = GetParm.toString(this, "ClipXOffset", "0");
        yoffset      = GetParm.toString(this, "ClipYOffset", "0");
        rectwidth    = GetParm.toString(this, "ClipWidth", "-1");
        rectheight   = GetParm.toString(this, "ClipHeight", "-1");
        arcwidth     = GetParm.toString(this, "ArcWidth", "-1");
        archeight    = GetParm.toString(this, "ArcHeight", "-1");

        //========= SCALE THE IMAGE ==============
        crr = new fcroproundrect();
        crr.setApplet(this);
        crr.setparameter(xoffset, 0);
        crr.setparameter(yoffset, 1);
        crr.setparameter(rectwidth, 2);
        crr.setparameter(rectheight, 3);
        crr.setparameter(archeight, 4);
        crr.setparameter(archeight, 5);
        img_pixels = crr.filter(img_pixels, img_width, img_height);
        img_width  = crr.getWidth();
        img_height = crr.getHeight();

        doStandardFilters();
    }
}
