import java.awt.image.*;
import java.awt.Color;
import java.awt.*;

public class Fade extends OffScr {

    public void init() {
        ffade ft;
        String percent;
        String fade_to_color;

        super.init();

        percent  = GetParm.toString(this, "Percent", "0");
        fade_to_color  = GetParm.toString(this, "FadeColor", null);

        //========= SCALE THE IMAGE ==============
        ft = new ffade();
        ft.setBackground(app_bg_color);
        ft.setparameter(percent, 0);
        ft.setparameter(fade_to_color, 1);
        img_pixels = ft.filter(img_pixels, img_width, img_height);
        img_width  = ft.getWidth();
        img_height = ft.getHeight();

        doStandardFilters();
    }
}
