import java.awt.image.*;
import java.awt.Color;
import java.awt.*;

public class SlantLeft extends OffScr {
    int         angle;

    public void init() {
        fslantleft sl;

        super.init();

        angle  = GetParm.toInt(this,  "Angle",    45);
        if(angle < 0 || angle >= 90) {
            System.out.println("Invalid slant angle: " + angle);
            angle = 0;
        }
        //========= SLANT THE IMAGE ==============
        sl = new fslantleft();
        sl.setparameter(Integer.toString(angle), 0);
        img_pixels = sl.filter(img_pixels, img_width, img_height);
        img_width = sl.getWidth();
        img_height = sl.getHeight();

        doStandardFilters();
    }
}
