import java.awt.*;
import java.awt.image.*;

public class DepthShade extends OffScr {
    protected String     depth_xoffset;
    protected String     depth_yoffset;
    protected String     depth_color;
    protected String     outline_color;

    public void init() {
        super.init();

        depth_color      = GetParm.toString(this,"DepthColor", null);
        outline_color    = GetParm.toString(this, "OutlineColor", null);
        depth_xoffset    = GetParm.toString(this, "DepthXOffset", "-10");
        depth_yoffset    = GetParm.toString(this, "DepthYOffset", "-10");

        //========= DEPTHFAD THE TEXT ==============
        fdepthshade depshd;
        depshd = new fdepthshade();
        depshd.setText(tx);
        depshd.setApplet(this);
        depshd.setFont(tx_font);
        depshd.setBackground(tx_bg_color!=null ? tx_bg_color : app_bg_color);
        depshd.setTransparent(tx_bg_color!=null ? false : true);
        depshd.setForeground(tx_color);
        depshd.setUnderline(tx_underline);
        depshd.setparameter(depth_xoffset, 0);
        depshd.setparameter(depth_yoffset, 1);
        depshd.setparameter(depth_color, 2);
        depshd.setparameter(outline_color, 3);
        tx_pixels = depshd.filter(null, 0, 0);     // These params get ignored
        tx_width = depshd.getWidth();
        tx_height = depshd.getHeight();

        doStandardFilters();
    }
}
