import java.awt.*;
import java.awt.image.*;
import java.util.*;

public class MultiColor extends OffScr {
    protected String    colors;

    public void init() {
        int i;
        int num_colors;
        StringTokenizer st;
        String colorlist[];

        super.init();

        colors  = GetParm.toString(this, "Colors", null);
        if(colors == null) {
            num_colors = 0;
            colorlist = null;
        } else {
            st = new StringTokenizer(colors, " ");
            num_colors = st.countTokens();
            colorlist = new String[num_colors];
            for(i=0;i<num_colors;i++)
                colorlist[i] = st.nextToken();
        }

        //========= MULTI-COLOR THE TEXT ==============
        fmulticolor mc;
        mc = new fmulticolor();
        mc.setText(tx);
        mc.setApplet(this);
        mc.setFont(tx_font);
        mc.setBackground(tx_bg_color!=null ? tx_bg_color : app_bg_color);
        mc.setTransparent(tx_bg_color!=null ? false : true);
        mc.setForeground(tx_color);
        mc.setUnderline(tx_underline);
        for(i=0;i<num_colors;i++)
            mc.setparameter(colorlist[i], i);
        tx_pixels = mc.filter(null, 0, 0);      // These params get ignored
        tx_width = mc.getWidth();
        tx_height = mc.getHeight();

        doStandardFilters();
    }
}
