import java.awt.*;
import java.awt.image.*;

public class Shadow extends OffScr {
    protected String    shadow_color;
    protected String    shadow_xoffset;
    protected String    shadow_yoffset;

    public void init() {
        int x, y;
        super.init();

        shadow_xoffset  = GetParm.toString(this, "ShadowXOffset", "2");
        shadow_yoffset  = GetParm.toString(this, "ShadowYOffset", "2");
        shadow_color    = GetParm.toString(this, "ShadowColor", "#646464");

        //========= SHADOW THE TEXT ==============
        fshadow sh;
        sh = new fshadow();
        sh.setText(tx);
        sh.setApplet(this);
        sh.setFont(tx_font);
        sh.setBackground(tx_bg_color!=null ? tx_bg_color : app_bg_color);
        sh.setTransparent(tx_bg_color!=null ? false : true);
        sh.setForeground(tx_color);
        sh.setUnderline(tx_underline);
        sh.setparameter(shadow_xoffset, 0);
        sh.setparameter(shadow_yoffset, 1);
        sh.setparameter(shadow_color, 2);
        tx_pixels = sh.filter(null, 0, 0);      // These params get ignored
        tx_width = sh.getWidth();
        tx_height = sh.getHeight();

        doStandardFilters();
    }
}
