import java.awt.Graphics;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Color;
import java.applet.Applet;
import java.awt.Event;
import java.awt.Image;

public class MoveLeft extends SAnimate {

    int         strIndex = 0;
    int         charIndex = 0;
    int         HorizontalIndex;

    public void init() {

        super.init();

        HorizontalIndex = size().width/2;
    }

    public synchronized void paint(Graphics g) {
        int i;

        super.paint(g);

        if(txcount <= 0)
            return;
        // Override the supers xoffset calculation
        if(horizcenter) {
            xoffset = (size().width / 2) - (total_widtha[strIndex] / 2);
        }

        // Skip spaces, it flows better
        if(charIndex < txa[strIndex].length())
            if(Character.isSpace(separateda[strIndex][charIndex]))
                charIndex = (charIndex == txa[strIndex].length() - 1) ? 0 :
                                            charIndex+1;


        // Draw the character that are already in place
        offGC.setColor(getForeground());
        for(i=0;i<charIndex;i++) {
            offGC.drawChars(separateda[strIndex], i, 1,
                        xoffset+xlocationa[strIndex][i], yoffset);
        }

        // Now draw the moving character if we're not at endofstring
        if(endofstring == false)
            offGC.drawChars(separateda[strIndex], charIndex, 1,
                    xoffset+xlocationa[strIndex][charIndex]+ 
                        ((HorizontalIndex > 0) ? HorizontalIndex : 0),
                    yoffset);

        g.drawImage(offScreen, 0, 0, this);
    }

    public void run() {
        endofstring = false;
        while (StringThread != null) {
            if(HorizontalIndex > 0) {
                HorizontalIndex -= 30;
                if(HorizontalIndex < 0)
                    HorizontalIndex = 0;
            } else {
                charIndex++;
                if(charIndex >= (txa[strIndex].length())) {
                    endofstring = true;
                } else {
                    HorizontalIndex = (size().width/2) +
                                            xlocationa[strIndex][charIndex];
                    if(HorizontalIndex + xlocationa[strIndex][charIndex] >
                                                        size().width)
                        HorizontalIndex = size().width - 
                                        xlocationa[strIndex][charIndex];
                }
            }
            if(endofstring == true) {
                repaint();
                try {Thread.sleep(rundelay);} catch (InterruptedException e){}
                endofstring = false;
                charIndex = 0;
                strIndex++;
                if(strIndex >= txcount)
                    strIndex = 0;
            } else {
                repaint();
                try {Thread.sleep(chardelay);} catch (InterruptedException e){}
            }
        }
    }

    public void start() {
        super.start();
        offGC.setColor(getBackground());
        offGC.fillRect(0, 0, size().width, size().height);
        charIndex = 0;
    }
}
