import java.awt.Graphics;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Color;
import java.applet.Applet;
import java.awt.Event;

public class Ticker extends SAnimate {

    int index = 0;
    int cur_xoffset;
    int move_dist;
    boolean thread_suspended;
    boolean forward = true;
    boolean reverse = false;

    public void init() {
        super.init();
        move_dist = GetParm.toInt(this,     "MoveDist", 20);
        reverse   = GetParm.toBoolean(this, "Reverse",  false);
        if(reverse == true)
            forward = false;
    }

    public synchronized void paint(Graphics g) {
        int i, j;

        super.paint(g);

        if(forward == true) {
            if(widtha[index] + cur_xoffset > 0) {
                cur_xoffset -= move_dist;
                offGC.setColor(getForeground());
                offGC.drawString(txa[index], cur_xoffset, yoffset);
            } else {
                endofstring = true;
            }
        } else {
            if(cur_xoffset < size().width) {
                cur_xoffset += move_dist;
                offGC.setColor(getForeground());
                offGC.drawString(txa[index], cur_xoffset, yoffset);
            } else {
                endofstring = true;
            }
        }

        g.drawImage(offScreen, 0, 0, this);
    }

    public void run() {
        int i;
        endofstring = false;
        cur_xoffset = size().width;
        thread_suspended = false;
        StringThread.setPriority(1);
        while (StringThread != null) {
            try {Thread.sleep(chardelay);} catch (InterruptedException e){}
            if(endofstring == true) {
                if(forward == true) {
                    index++;
                    if(index == txcount)
                        index = 0;
                } else {
                    index--;
                    if(index < 0)
                        index = txcount - 1;
                }
                try {Thread.sleep(rundelay);} catch (InterruptedException e){}
                if(forward == true)
                    cur_xoffset = size().width;
                else
                    cur_xoffset = -widtha[index];
                endofstring = false;
            } else
                repaint();
        }
    }

    public boolean keyDown(Event evt, int key) {
        int x = evt.x;
        int y = evt.y;

        if(key == 'm') {
            move_dist += 1;
            getAppletContext().showStatus("New distance: " + move_dist);
            return true;
        } else if(key == 'l') {
            move_dist -= 1;
            if(move_dist <= 0)
                move_dist = 1;
            getAppletContext().showStatus("New distance: " + move_dist);
            return true;
        }
        return super.keyDown(evt, key);
    }

    public boolean mouseDown(Event evt, int x, int y) {

        if((evt.modifiers & Event.SHIFT_MASK) != 0) {
            forward = !forward;
        } else {
            if(thread_suspended == true) {
                StringThread.resume();
                thread_suspended = false;
            } else {
                StringThread.suspend();
                thread_suspended = true;
            }
        }
        
        return true;
    }
}
