import java.awt.Graphics;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Color;
import java.applet.Applet;
import java.awt.Event;
import java.awt.Image;

public class UpAndOver extends SAnimate {

    int         strIndex = 0;
    int         charIndex = 0;
    int         maxvert = 5;
    int         VerticalIndex;
    boolean     string_complete = false;
    int         cur_xoffset;
    int         move_left_dist;

    public void init() {

        super.init();

        move_left_dist = GetParm.toInt(this, "MoveLeftDist", 10);
    }

    public synchronized void paint(Graphics g) {
        int i;

        super.paint(g);

        if(string_complete == true) {
            int lastindex = strIndex - 1;
            if(lastindex < 0)
                lastindex = txcount-1;
            if(widtha[lastindex] + cur_xoffset > 0) {
                cur_xoffset -= move_left_dist;
                offGC.setColor(getForeground());
                offGC.drawString(txa[lastindex], cur_xoffset, yoffset);
                g.drawImage(offScreen, 0, 0, this);
            } else
                string_complete = false;
            return;
        }

        // Override the supers xoffset calculation
        if(horizcenter) {
            xoffset = (size().width / 2) - (total_widtha[strIndex] / 2);
        }

        // Skip spaces, it flows better
        if(Character.isSpace(separateda[strIndex][charIndex]))
            charIndex = (charIndex == txa[strIndex].length() - 1) ? 0 :
                                        charIndex+1;


        // Draw the character that are already in place
        offGC.setColor(getForeground());
        for(i=0;i<charIndex;i++) {
            offGC.drawChars(separateda[strIndex], i, 1,
                        xoffset+xlocationa[strIndex][i], yoffset);
        }

        // Skip spaces, it flows better
        if(Character.isSpace(separateda[strIndex][charIndex]))
            charIndex = (charIndex == txa[strIndex].length() - 1) ? 0 :
                                        charIndex+1;
        
        // Now draw the moving character
        offGC.setColor(getForeground());
        offGC.drawChars(separateda[strIndex], charIndex, 1,
                    xoffset+xlocationa[strIndex][charIndex],
                    yoffset+(VerticalIndex*maxvert));
        if(VerticalIndex > 0)
            VerticalIndex--;
        else {
            VerticalIndex = maxvert;
            charIndex = (charIndex == txa[strIndex].length() - 1)
                                                 ? 0 : charIndex+1;
            if(charIndex == 0) {
                VerticalIndex = maxvert;
                endofstring = true;
                strIndex++;
                if(strIndex >= txcount)
                    strIndex = 0;
                cur_xoffset = xoffset;
                string_complete = true;
            }
        }




        g.drawImage(offScreen, 0, 0, this);
    }

    public void run() {
        endofstring = false;
        while (StringThread != null) {
            try {Thread.sleep(chardelay);} catch (InterruptedException e){}
            if(endofstring == true) {
                try {Thread.sleep(rundelay);} catch (InterruptedException e){}
                endofstring = false;
            } else
                repaint();
        }
    }

    public void start() {
        super.start();
        offGC.setColor(getBackground());
        offGC.fillRect(0, 0, size().width, size().height);
        charIndex = 0;
    }
}
