import java.awt.*;
import java.awt.image.*;
import java.util.*;

public class fcropoval extends ImgFilt {
    int oval_x = 0;
    int oval_y = 0;
    int oval_w = -1;
    int oval_h = -1;

    public void setparameter(String str, int i) {
        switch(i) {
        case 0:
            oval_x = Integer.parseInt(str);
            break;
        case 1:
            oval_y = Integer.parseInt(str);
            break;
        case 2:
            oval_w = Integer.parseInt(str);
            break;
        case 3:
            oval_h = Integer.parseInt(str);
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y, i;
        int index;
        Image image;
        Graphics g;
        int pixels[];
        boolean retval;
        int bg_value;
	ImgGetr ig;

        if(p1.length != (w*h)) {
            System.out.println("cropoval filter: got array of wrong size");
            return null;
        }

        if(oval_w == -1)
            oval_w = w;
        if(oval_h == -1)
            oval_h = h;

        image = applet.createImage(w, h);
        g = image.getGraphics();
	g.setColor(Color.white);
	g.fillRect(0, 0, w, h);
        g.setColor(Color.black);
        g.fillOval(oval_x, oval_y, oval_w, oval_h);

        // Grab the pixels
	ig = new ImgGetr(applet);
        pixels = ig.getPixels(image, applet);

        newpixels = new int[h * w];

	bg_value = 0xff000000;	// White
        for(y=0;y<h;y++) {
            for(x=0;x<w;x++) {
                index = (y*w) + x;
                if(pixels[index] == bg_value)
                    newpixels[index] = p1[index];
                else
                    newpixels[index] = 0x00ffffff & bg_value;
            }
        }
        new_width  = w;
        new_height = h;
        return newpixels;
    }
}
