import java.awt.*;
import java.awt.image.*;
import java.util.*;

public class fcroproundrect extends ImgFilt {
    int rr_x = 0;
    int rr_y = 0;
    int rr_w = -1;
    int rr_h = -1;
    int rr_archeight = -1;
    int rr_arcwidth = -1;

    public void setparameter(String str, int i) {
        switch(i) {
        case 0:
            rr_x = Integer.parseInt(str);
            break;
        case 1:
            rr_y = Integer.parseInt(str);
            break;
        case 2:
            rr_w = Integer.parseInt(str);
            break;
        case 3:
            rr_h = Integer.parseInt(str);
            break;
        case 4:
            rr_archeight = Integer.parseInt(str);
            break;
        case 5:
            rr_arcwidth = Integer.parseInt(str);
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y, i;
        int index;
        Image image;
        Graphics g;
        int pixels[];
        boolean retval;
        int bg_value;
	ImgGetr ig;

        if(p1.length != (w*h)) {
            System.out.println("croprrct filter: got array of wrong size");
            return null;
        }

        if(rr_w == -1)
            rr_w = w;
        if(rr_h == -1)
            rr_h = h;
        if(rr_archeight == -1)
            rr_archeight = rr_h / 2;
        if(rr_arcwidth == -1)
            rr_arcwidth = rr_w / 2;

        image = applet.createImage(w, h);
        g = image.getGraphics();
	g.setColor(Color.white);
	g.fillRect(0, 0, w, h);
        g.setColor(Color.black);
        g.fillRoundRect(rr_x, rr_y, rr_w, rr_h, rr_arcwidth, rr_archeight);

        // Grab the pixels
	ig = new ImgGetr(applet);
        pixels = ig.getPixels(image, applet);

        newpixels = new int[h * w];

	bg_value = 0xff000000;	// White
        for(y=0;y<h;y++) {
            for(x=0;x<w;x++) {
                index = (y*w) + x;
                if(pixels[index] == bg_value)
                    newpixels[index] = p1[index];
                else
                    newpixels[index] = 0x00ffffff & bg_value;
            }
        }
        new_width  = w;
        new_height = h;
        return newpixels;
    }
}
