import java.awt.*;
import java.awt.image.*;
import java.util.*;

public class fmulticolor extends ImgFilt {
    Vector colors = null;

    public void setparameter(String str, int i) {
        if(colors == null) {
            colors = new Vector();
        }
        Color c = String2Color(str);
        if(c == null)
            return;
        colors.addElement(c);
    }

    public int[] filter(int[] p1, int w, int h) {
        int     x = -1, y = -1;
        Image    image;
        Graphics g;
        int      ascent;
        int      descent;
        char     separated[];
        int      total_width;
        int      xlocation[];
        int      xwidth[];
        int      lastx = 0, lasty = 0;
        int      i;
        int      midpoint;
        int      charwidth;
        int      str_len;
        FontMetrics fontmetrics;
        int pixels[];
        boolean retval;
        ftransp tp;
        int vector_index;
	ImgGetr ig;

        str_len = tx.length();
        separated =  new char [str_len];
        xlocation =  new int  [str_len];
        xwidth    =  new int  [str_len];
        tx.getChars(0, str_len, separated, 0);
        fontmetrics = applet.getFontMetrics(font);
        ascent = fontmetrics.getAscent();
        descent = fontmetrics.getDescent();

        // If the colors Vector has not been set then
        // default it to black
        if(colors == null)
            setparameter("black", 0);

        // Calculate the x locations for each character based on width
        total_width = 0;
        for(i=0;i<str_len;i++) {
            xwidth[i] = fontmetrics.charWidth(separated[i]);
            total_width += xwidth[i];
            if(i+1<str_len)
                xlocation[i+1] = total_width;
        }

        new_width = fontmetrics.stringWidth(tx);
        new_height = fontmetrics.getHeight();

        // Recreate the image because we need the bigger size
        image = applet.createImage(new_width, new_height); 
        g = image.getGraphics();
        g.setFont(font);
        g.setColor(bg);
        g.fillRect(0, 0, new_width, new_height);

        // Underline
        drawUnderline(g, fontmetrics, 0,
                        ascent+Math.max(1, (descent/4)),
                        new_width, fg);

        lastx = 0;
        lasty = 0;
        x = 0;
        y = 0;
        vector_index = 0;
        for(i=0;i<str_len;i++) {
            x = xlocation[i];
            y = ascent;
            g.setColor((Color)colors.elementAt(vector_index));
            g.drawChars(separated, i, 1, x, y);
            vector_index++;
            if(vector_index >= colors.size())
                vector_index = 0;
        }

	ig = new ImgGetr(applet);
        pixels = ig.getPixels(image, applet);
        if(transparent) {
            tp = new ftransp();
            tp.setTransparentColor(bg);
            pixels = tp.filter(pixels, new_width, new_height);
        }
        return pixels;
    }
}
