public class fnegative extends ImgFilt {
    int subfrom = 255;

    public void setparameter(String str, int i) {
        switch(i) {
        case 0:
            subfrom = Integer.parseInt(str);
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y, i;
        int index, new_index;
        int alpha, red, green, blue;
        int nalpha, nred, ngreen, nblue;

        if(p1.length != (w*h)) {
            System.out.println("negative filter: wrong size array");
            System.out.println("p1.length = " + p1.length + " (w,h) = "
                                + w + "," + h);
            return null;
        }

        newpixels = new int[h * w];

        new_index = 0;
        for(y=0;y<h;y++) {
            for(x=0;x<w;x++) {
                index = (y*w) + x;
                alpha = (p1[index] & 0xff000000) >>> 24;
                red   = (p1[index] & 0x00ff0000) >> 16;
                green = (p1[index] & 0x0000ff00) >> 8;
                blue  = (p1[index] & 0x000000ff);

                nred   = Math.abs(subfrom - red);
                ngreen = Math.abs(subfrom - green);
                nblue  = Math.abs(subfrom - blue);
                newpixels[new_index++] = 
                    (alpha << 24) | (nred << 16) | (ngreen << 8) | nblue;
            }
        }
        new_width  = w;
        new_height = h;
        return newpixels;
    }
}
