import java.awt.*;
import java.awt.image.*;
import java.util.*;

public class fremoverectangle extends ImgFilt {
    int rect_x = 0;
    int rect_y = 0;
    int rect_w = -1;
    int rect_h = -1;

    public void setparameter(String str, int i) {
        switch(i) {
        case 0:
            rect_x = Integer.parseInt(str);
            break;
        case 1:
            rect_y = Integer.parseInt(str);
            break;
        case 2:
            rect_w = Integer.parseInt(str);
            break;
        case 3:
            rect_h = Integer.parseInt(str);
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y, i;
        int index;
        Image image;
        Graphics g;
        int pixels[];
        boolean retval;
        int bg_value;
	ImgGetr ig;

        if(p1.length != (w*h)) {
            System.out.println("remvrect filter: got array of wrong size");
            return null;
        }

        if(rect_w == -1)
            rect_w = w;
        if(rect_h == -1)
            rect_h = h;

        image = applet.createImage(w, h);
        g = image.getGraphics();
        g.setColor(Color.black);
	g.fillRect(0, 0, w, h);
	g.setColor(Color.white);
        g.fillRect(rect_x, rect_y, rect_w, rect_h);

        // Grab the pixels
	ig = new ImgGetr(applet);
        pixels = ig.getPixels(image, applet);

        newpixels = new int[h * w];

	bg_value = 0xff000000;	// White
        for(y=0;y<h;y++) {
            for(x=0;x<w;x++) {
                index = (y*w) + x;
                if(pixels[index] == bg_value)
                    newpixels[index] = p1[index];
                else
                    newpixels[index] = 0x00ffffff & p1[index];
            }
        }
        new_width  = w;
        new_height = h;
        return newpixels;
    }
}
