import java.awt.Color;

public class freplclr extends ImgFilt {
    String old_color_str;
    String new_color_str;
    int old_color_value;
    int new_color_value;
    Color old_color;
    Color new_color;

    public void setparameter(String str, int i) {
        switch(i) {
        case 0:
            old_color_str = str;
            old_color = String2Color(old_color_str);;
            old_color_value = (0xFF << 24) | 
                            (old_color.getRed()   << 16) |
                            (old_color.getGreen() <<  8) |
                            (old_color.getBlue());
            break;
        case 1:
            new_color_str = str;
            new_color = String2Color(new_color_str);;
            new_color_value = (0xFF << 24) | 
                            (new_color.getRed()   << 16) |
                            (new_color.getGreen() <<  8) |
                            (new_color.getBlue());
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y, i;
        int index, new_index;

        if(p1.length != (w*h)) {
            System.out.println("transpar filter: got array of wrong size");
            return null;
        }

        newpixels = new int[h * w];

        new_index = 0;
        for(y=0;y<h;y++) {
            for(x=0;x<w;x++) {
                index = (y*w) + x;
                if(p1[index] == old_color_value) {
                    newpixels[new_index++] = new_color_value;
                } else
                    newpixels[new_index++] = p1[index];
            }
        }
        new_width  = w;
        new_height = h;
        return newpixels;
    }
}
