import java.awt.*;
import java.awt.image.*;

public class fsmoothtext extends ImgFilt {

    public int[] filter(int[] p1, int w, int h) {
        int x, y;
        int index = 0;
        int k,l;
        int fgcount;
        int red, green, blue;
        Font bigfont;
        FontMetrics bigfontmetrics;
        Image i1;
        int bigpixels[];
        Graphics g;
        int fg_red, fg_green, fg_blue;
        int bg_red, bg_green, bg_blue;
        int fg_value;
        int bg_value;
        int[] pixels;
        int bigw, bigh;
        int mul = 4;
        int mulsqr = mul*mul;
        boolean retval;
        ftransp tp;
        int bigascent, bigdescent;
	ImgGetr ig;

	if(tx == null) {
	    new_width = w;
	    new_height = h;
	    return p1;
	}
	    
        // Get the background and foreground color info
        fg_red   = fg.getRed();
        fg_green = fg.getGreen();
        fg_blue  = fg.getBlue();
        fg_value = 0xff000000 | (fg_red << 16) | (fg_green << 8) | fg_blue;

        bg_red   = bg.getRed();
        bg_green = bg.getGreen();
        bg_blue  = bg.getBlue();
        bg_value = 0xff000000 | (bg_red << 16) | (bg_green << 8) | bg_blue;

        // Draw the string into an off screen image, "mul" times the normal size
        bigfont = new Font(font.getName(), font.getStyle(), font.getSize()*mul);
        bigfontmetrics = applet.getFontMetrics(bigfont);
        bigascent = bigfontmetrics.getAscent();
        bigdescent = bigfontmetrics.getDescent();
        bigw = bigfontmetrics.stringWidth(tx);
        bigh = bigfontmetrics.getHeight();
        // Pad bigw and bigh so that they are multiples of "mul"
        if(bigw % mul != 0)
            bigw += (mul - (bigw % mul));
        if(bigh % mul != 0)
            bigh += (mul - (bigh % mul));
        new_width = bigw / mul;
        new_height = bigh / mul;
        i1 = applet.createImage(bigw, bigh); 
        g = i1.getGraphics();
        g.setFont(bigfont);
        g.setColor(bg);
        g.fillRect(0, 0, bigw, bigh);
        g.setColor(fg);
        g.drawString(tx, 0, bigascent);
        drawUnderline(g, bigfontmetrics, 0,
                       bigascent+Math.max(1, (bigdescent/4)),
                       bigw, fg);

        // Now get the pixels from the big image
        pixels = new int[new_width * new_height];
	ig = new ImgGetr(applet);
        bigpixels = ig.getPixels(i1, applet);

        for(y=0;y<bigh;y+=mul) {
            for(x=0;x<bigw;x+=mul) {
                fgcount = 0;
                for(k=0;k<mul;k++) {
                    for(l=0;l<mul;l++) {
                        if(y+k < bigh && x+l < bigw && 
                                bigpixels[((y+k)*bigw)+x+l] == fg_value)
                            fgcount++;
                    }
                }
                if(fgcount == 0) {
                    pixels[index++] = bg_value;
                } else {
                    if(fg_red > bg_red)
                        red = bg_red + (fg_red - bg_red)*fgcount/(mulsqr);
                    else
                        red = bg_red - (bg_red - fg_red)*fgcount/(mulsqr);
                    if(fg_green > bg_green)
                        green = bg_green + (fg_green - bg_green)*fgcount/(mulsqr);
                    else
                        green = bg_green - (bg_green - fg_green)*fgcount/(mulsqr);
                    if(fg_blue > bg_blue)
                        blue = bg_blue + (fg_blue - bg_blue)*fgcount/(mulsqr);
                    else
                        blue = bg_blue - (bg_blue - fg_blue)*fgcount/(mulsqr);


                    pixels[index++] = (0xff000000 | (red << 16) | (green << 8) | blue);
                }
            }
        }
        if(transparent) {
            tp = new ftransp();
            tp.setTransparentColor(bg);
            pixels = tp.filter(pixels, new_width, new_height);
        }
        return pixels;
    }
}
