public class ftransparent extends ImgFilt {
    int transparent_factor = 0;

    public void setparameter(String param, int i) {
        switch(i) {
        case 0:
            transparent_factor = Integer.parseInt(param);
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y, i;
        int index, new_index;
        int alpha;

        if(p1.length != (w*h)) {
            System.out.println("transimg filter: got array of wrong size");
            return null;
        }

        newpixels = new int[h * w];

        new_index = 0;
        for(y=0;y<h;y++) {
            for(x=0;x<w;x++) {
                index = (y*w) + x;
                alpha = p1[index] >>> 24;

                alpha = alpha * (100 - transparent_factor) / 100;
                alpha = Math.min(255, alpha);
                alpha = Math.max(0, alpha);
                newpixels[index] = (alpha << 24) | (p1[index] & 0x00ffffff);

                new_index++;
            }
        }
        new_width  = w;
        new_height = h;
        return newpixels;
    }
}
