import java.awt.*;
import java.applet.Applet;
import java.applet.AudioClip;
import java.net.URL;

/*
 * URLButton is a simple audio applet.  Two buttons are
 */
public class URLButton extends Applet {
    Button      go;             // The Play and Stop Buttons
    Color       bg_color;
    Color       fg_color;
    String      str;
    URL         url;
    Font        buttonfont;

    public void init() {
        bg_color       = GetParm.toColor(this, "BGColor", null);
        fg_color       = GetParm.toColor(this, "FGColor", null);
        str            = GetParm.toString(this, "Label", null);
        url            = GetParm.toURL(this, "URL");
        buttonfont     = GetParm.toFont(this,   "ButtonFont",
                                        "ButtonStyle", "ButtonPointSize");

        // Set the background and foreground colors, if specified
        if(bg_color != null)
            setBackground(bg_color);
        if(fg_color != null)
            setForeground(fg_color);

        go = new Button(str);
        go.setFont(buttonfont);
        add(go);
    }

    // The action function gets called when 
    // the button is pressed.
    public boolean action(Event evt, Object o) {
        if(url != null)
            getAppletContext().showDocument(url);
        return true;
    }
}
