import java.awt.image.*;
import java.awt.Color;
import java.awt.*;

public class Scale extends OffScr {

    public void init() {
        fscale sc;
        String perc_x;
        String perc_y;
        String perc;

        super.init();

        perc_x  = GetParm.toString(this, "ScaleX", "100");
        perc_y  = GetParm.toString(this, "ScaleY", "100");
        perc    = GetParm.toString(this, "Scale",   null);
        if(perc != null) {
            perc_x = perc;
            perc_y = perc;
        }

        //========= SCALE THE IMAGE ==============
        sc = new fscale();
        sc.setparameter(perc_x, 0);
        sc.setparameter(perc_y, 1);
        img_pixels = sc.filter(img_pixels, img_width, img_height);
        img_width  = sc.getWidth();
        img_height = sc.getHeight();

        doStandardFilters();
    }
}
