import java.awt.image.*;
import java.awt.Color;
import java.awt.*;

public class SlantDown extends OffScr {
    int         angle;

    public void init() {
        fslantdown sd;

        super.init();

        angle  = GetParm.toInt(this,  "Angle",    45);
        if(angle < 0 || angle >= 90) {
            System.out.println("Invalid slant angle: " + angle);
            angle = 0;
        }
        //========= SLANT THE IMAGE ==============
        sd = new fslantdown();
        sd.setparameter(Integer.toString(angle), 0);
        img_pixels = sd.filter(img_pixels, img_width, img_height);
        img_width = sd.getWidth();
        img_height = sd.getHeight();

        doStandardFilters();
    }
}
