import java.awt.image.*;
import java.awt.Color;
import java.awt.*;
import java.util.*;

public class TransColor extends OffScr {
    String all_colors;
    String str_color[];

    public void init() {
        ftranscolor mt;
        StringTokenizer st;
        int num_colors;
        int i;

        super.init();

        all_colors  = GetParm.toString(this, "Colors", null);

        if(all_colors != null) {
            st = new StringTokenizer(all_colors, " ");
            num_colors = st.countTokens();
            str_color = new String[num_colors];
            for(i=0;i<num_colors;i++) {
                str_color[i] = st.nextToken();
            }
            //========= MAKE THE IMAGE TRANSPARENT ==============
            mt = new ftranscolor();
            for(i=0;i<num_colors;i++)
                mt.setparameter(str_color[i], i);
            img_pixels = mt.filter(img_pixels, img_width, img_height);
            img_width = mt.getWidth();
            img_height = mt.getHeight();
        }

        doStandardFilters();
    }
}
