import java.awt.image.*;
import java.awt.Color;
import java.awt.*;

public class WaveImage extends OffScr {
    String   amplitude;
    String   wavetextlength;
    String   XTranslate;
    String   YTranslate;
    String   BeginRange;
    String   EndRange;

    public void init() {
        fwaveimage wavetext;

        super.init();

        amplitude  = GetParm.toString(this,  "Amplitude",  "10");
        wavetextlength  = GetParm.toString(this, "WaveLength", "10");
        XTranslate  = GetParm.toString(this, "XTranslate", "0");
        YTranslate  = GetParm.toString(this, "YTranslate", "0");
        BeginRange  = GetParm.toString(this, "BeginRange", "0");
        EndRange    = GetParm.toString(this, "EndRange",   "-1");

        //========= ROTATE THE IMAGE ==============
        wavetext = new fwaveimage();
        wavetext.setBackground(app_bg_color);
        wavetext.setparameter(amplitude, 0);
        wavetext.setparameter(wavetextlength, 1);
        wavetext.setparameter(XTranslate, 2);
        wavetext.setparameter(YTranslate, 3);
        wavetext.setparameter(BeginRange, 4);
        wavetext.setparameter(EndRange, 5);
        img_pixels = wavetext.filter(img_pixels, img_width, img_height);
        img_width = wavetext.getWidth();
        img_height = wavetext.getHeight();

        doStandardFilters();
    }
}
