import java.awt.*;
import java.awt.image.*;

public class DepthFade extends OffScr {
    protected String     depth_xoffset;
    protected String     depth_yoffset;
    protected String     depth_color;
    protected String     outline_color;

    public void init() {
        super.init();

        depth_color      = GetParm.toString(this,"DepthColor", null);
        outline_color    = GetParm.toString(this, "OutlineColor", null);
        depth_xoffset    = GetParm.toString(this, "DepthXOffset", "-10");
        depth_yoffset    = GetParm.toString(this, "DepthYOffset", "-10");

        //========= DEPTHFAD THE TEXT ==============
        fdepthfade df;
        df = new fdepthfade();
        df.setText(tx);
        df.setApplet(this);
        df.setFont(tx_font);
        df.setBackground(tx_bg_color!=null ? tx_bg_color : app_bg_color);
        df.setTransparent(tx_bg_color!=null ? false : true);
        df.setForeground(tx_color);
        df.setUnderline(tx_underline);
        df.setparameter(depth_xoffset, 0);
        df.setparameter(depth_yoffset, 1);
        df.setparameter(depth_color, 2);
        df.setparameter(outline_color, 3);
        tx_pixels = df.filter(null, 0, 0);     // These params get ignored
        tx_width = df.getWidth();
        tx_height = df.getHeight();

        doStandardFilters();
    }
}
