import java.awt.*;
import java.awt.image.*;

public class Emboss extends OffScr {
    protected String       depth;
    protected String       contrast;

    public void init() {

        super.init();
        depth           = GetParm.toString(this, "Depth", "1");
        contrast        = GetParm.toString(this, "Contrast", "50");

        //========= EMBOSS THE TEXT ==============
        femboss em;
        em = new femboss();
        em.setText(tx);
        em.setApplet(this);
        em.setFont(tx_font);
        em.setBackground(tx_bg_color!=null ? tx_bg_color : app_bg_color);
        em.setTransparent(tx_bg_color!=null ? false : true);
        em.setForeground(tx_color);
        em.setUnderline(tx_underline);
        em.setparameter(depth, 0);
        em.setparameter(contrast, 1);
        tx_pixels = em.filter(null, 0, 0);      // These params get ignored
        tx_width = em.getWidth();
        tx_height = em.getHeight();

        doStandardFilters();
    }
}
