import java.awt.*;
import java.awt.image.*;

public class SoftShadow extends OffScr {
    protected String     shadow_color;
    protected String     shadow_xoffset;
    protected String     shadow_yoffset;
    protected String     soft_thickness;
    protected Color      light_shadow[];

    public void init() {
        int x, y;

        super.init();

        shadow_color   = GetParm.toString(this,"ShadowColor", "#646464");
        shadow_xoffset = GetParm.toString(this, "ShadowXOffset", "2");
        shadow_yoffset = GetParm.toString(this, "ShadowYOffset", "2");
        soft_thickness = GetParm.toString(this, "SoftThickness", "2");

        //========= SHADOW THE TEXT ==============
        fsoftshadow sh;
        sh = new fsoftshadow();
        sh.setText(tx);
        sh.setApplet(this);
        sh.setFont(tx_font);
        sh.setForeground(tx_color);
        sh.setBackground(tx_bg_color!=null ? tx_bg_color : app_bg_color);
        sh.setTransparent(tx_bg_color!=null ? false : true);
        sh.setUnderline(tx_underline);
        sh.setparameter(shadow_xoffset, 0);
        sh.setparameter(shadow_yoffset, 1);
        sh.setparameter(shadow_color, 2);
        sh.setparameter(soft_thickness, 3);
        tx_pixels = sh.filter(null, 0, 0);      // These params get ignored
        tx_width = sh.getWidth();
        tx_height = sh.getHeight();

        doStandardFilters();
    }
}
